#REGISTER NONE
'calculate square roots of arbitrary sized integers
'The number is stored in the array n() and is destroyed. The answer appears in the array c()
'm() is used as a scratch register.
'if n() is 0 after the calculation then the result is exact.
'if you want places after the point then, provided the arrays are dimension big enough, just set BitsToDo& to however
'many bits are required. The limit is 2^31 bits.
'The top 2 bits of the initial number must be 0. If they aren't then it needs to be padded with 2 leading DWORDs of 0.

FUNCTION PBMAIN
'example of how DWORD array and number should line up:
'for the number=&h000000000000123456789abcf123e5675a5bced1012dc2e1 (pad out to even number of DWORDs with leading zeroes)
'the initial data in the array would be this:

'n(0)=0
'n(1)=&h1234
'n(2)=&h56789abc
'n(3)=&hf123e567
'n(4)=&h5a5bced1
'n(5)=&h012dc2e1


'now do a real calculation on the following 1024 bit HEX number
'the original number, in hex, an exact even number of DWORDS, add preceeding 0's as needed

IF COMMAND$="" THEN
    'this is the same number you used but with the leading F changed to a 3 so that
number$=       "0fC2FF635A4944FC48431F39294CD9C2840C17453D99B9A55EA89A35385AB4123DC584519335ED60B"
number$=number$+"F66C948F47227EC6DB25C82A16CB41DA272BB0CBA13DCCB32583598563E1FFF110B032A3DD63DC8C"
number$=number$+"28F64CA463B5FB38F743660DFA069FA7D26193E28E07C937728E1630E9A469452810E634B47197B2"
number$=number$+"3275238100000063"

    ELSE
number$=COMMAND$
END IF


'Make sure number is and even number of DWORDs by padding front with 0s
ln&=LEN(number$) MOD 16
IF ln&<>0 THEN number$=RIGHT$("0000000000000000",16-ln&)+number$

PRINT "len=";LEN(number$)

SizeOfNumber&=LEN(number$)/8   'size in DWORDs needs to be even to avoid a 16 bit shift at the end

BitsToDo&=SizeOfNumber& * 16     'result is always half the size of the original number
limit&= SizeOfNumber&/2         'noof DWORDS needed for answer Note: assumes size of number is even number of DWORDs.

DIM  c(SizeOfNumber&) AS DWORD, n(SizeOfNumber&) AS DWORD,m(SizeOfNumber&) AS DWORD
DIM digit AS LONG

'extract the number into the dword array
PRINT "original number= "
FOR r&=1 TO LEN(number$) STEP 8
    md$=MID$(number$,r&,8)
    PRINT md$;
    n((r&-1)/8)=VAL("&h"+md$)
NEXT
PRINT :PRINT


c(0)=&h40000000     'the initial subtractor. This is just the 2nd MSB set, all other bits of c() are zeroed
np&=VARPTR(n(0))    'pointers to the start of the number..
cp&=VARPTR(c(0))    '..the subtractor
mp&=VARPTR(m(0))    '.. and scratch area
digit =1            'the number of the bit I'm calculating

!nop
'!int 3
!nop
!nop

!nop
 !nop              'nops just used to align code on a 16 byte boundary.
 !nop
 !nop
 !nop
 !nop
 !nop
 !nop
 !nop


%RDTSC=&h310f
a&&=0:b&&=0:cc&&=0
!pushad
'!cli
!cpuid
!dw %RDTSC
!mov a&&[4],edx
!mov a&&,eax

#IF 1
'All the work is done in ASM starting here:
'This is the point that need to be ALIGNed 16
!pushad                 'save all registers
!mov edi,cp&            'get pointers to the 3 main arrays
!mov esi,np&
!mov edx,mp&

mainlp:

'short cut, do a check of the most significant word to see if we really need to do the whole subtraction
!mov eax,[esi]
!sub eax,[edi]
!jc short subfail             'subtract will fail, so don't waste time doing it all.

'subtract
!mov ecx,SizeOfNumber&   'start the full subtraction,

!clc                    'must be clear at start
lp1:
'do the subtraction
!mov eax,[esi+ecx*4]    'get part of number
!sbb eax,[edi+ecx*4]    'subtract the subtractor
!mov [edx+ecx*4],eax    'store result in alternative array

!dec ecx                'done them all?
!jns short lp1          'no, go back for next word

!jnc short subpass      'if carry is clear at the end then the subtract succeeded
!nop
!nop

'must have gone negative so this digit is finished
'restore n() to what it was before the subtract by adding the number back in..
'..don't need to restore n(), just don't swap the pointers so next time I point to the old n() again

subfail:
  'update the subtractor
!mov eax,digit          'get the current bit number

!mov ebx,eax
!xor ebx,31
!btr [edi],ebx          'clear current bit

!inc eax                'get number of next bit
!nop
!mov ebx,eax
!xor ebx,31
!bts [edi],ebx          'set next bit

!mov digit,eax          'update bit counter

!jmp short shftit       'skip to next digit


subpass:
'we get here if a subtract succeeded, so we update the answer and the subtractor accordingly

!xchg esi,edx           'switch to subtracted number
'update subtractor
!mov eax,digit          'get the current bit number

!mov ebx,eax
!xor ebx,31
!btr [edi],ebx          'clear current bit

!dec eax                'point to previous bit

!mov ebx,eax
!xor ebx,31

!bts [edi],ebx          'set previous bit
!add eax,2              'get number of next bit

!mov ebx,eax
!xor ebx,31
!bts [edi],ebx          'set next bit

!mov digit,eax          'update bit counter

!nop
!nop
 !nop
 !nop
shftit:
    'shift the remaining number
!mov ecx,SizeOfNumber&


!clc

shiftlp:
!rcl dword ptr [esi+ecx*4],1
!dec ecx                    'loop counter
!jns short shiftlp          'Done them all?
!nop
!nop
 !nop

!dec BitsToDo&              'done all the bits needed?
!jnz  mainlp           'no, go back for another

!mov remainder&,esi         'pointer to remainder
!popad                      'yes, restore all registers

#ENDIF


!cpuid
!dw %RDTSC
!mov b&&[4],edx
!mov b&&,eax
'!sti
!popad

cc&&=(b&&-a&&)
'now print out the answer from c().
PRINT "Answer= "
FOR r& = 0 TO limit&  -1
    PRINT RIGHT$("00000000"+HEX$(c(r&)),8);
    NEXT
PRINT:PRINT


PRINT "Remainder= "
FOR r& = 0 TO limit& -1
    IF remainder&=mp& THEN
        PRINT RIGHT$("00000000"+HEX$(m(r&)),8);
    ELSE
        PRINT RIGHT$("00000000"+HEX$(n(r&)),8);
    END IF
NEXT
PRINT:PRINT

PRINT "bits done=";digit&
PRINT "clks="cc&&-64


WAITKEY$

END FUNCTION
